Index: trunk/src/lib/script_engine/script.cc
===================================================================
--- trunk/src/lib/script_engine/script.cc	(revision 9682)
+++ trunk/src/lib/script_engine/script.cc	(revision 9869)
@@ -18,20 +18,22 @@
 #include "luaincl.h"
 #include "debug.h"
-#include "util/loading/resource_manager.h"
-
+
+#include "loading/resource_manager.h"
 #include "loading/load_param.h"
 #include "parser/tinyxml/tinyxml.h"
 
-#include "class_list.h"
-CREATE_SCRIPTABLE_CLASS(Script, CL_SCRIPT,
-                    addMethod("addObject", ExecutorLua2<Script,const std::string&, const std::string& >(&Script::addObject))
-                    ->addMethod("registerClass", ExecutorLua1<Script,const std::string&>(&Script::registerClass))
-                    ->addMethod("selectFunction", ExecutorLua2ret<Script, bool, const std::string&, int >(&Script::selectFunction))
-                    ->addMethod("executeFunction", ExecutorLua0ret<Script,bool >(&Script::executeFunction))
+ObjectListDefinition(Script);
+
+CREATE_SCRIPTABLE_CLASS(Script,
+                    addMethod("addObject", Executor2<Script, lua_State*,const std::string&, const std::string& >(&Script::addObject))
+                    ->addMethod("registerClass", Executor1<Script, lua_State*,const std::string&>(&Script::registerClass))
+                    ->addMethod("selectFunction", Executor2ret<Script, lua_State*, bool, const std::string&, int >(&Script::selectFunction))
+                    ->addMethod("executeFunction", Executor0ret<Script, lua_State*,bool >(&Script::executeFunction))
                      );
+
 
 Script::Script(const TiXmlElement* root)
 {
-  this->setClassID(CL_SCRIPT, "Script");
+  this->registerObject(this, Script::_objectList);
 
   returnCount = argumentCount = 0;
@@ -52,5 +54,5 @@
 Script::Script(const std::string& filename)
 {
-  this->setClassID(CL_SCRIPT, "Script");
+  this->registerObject(this, Script::_objectList);
 
   returnCount = argumentCount = 0;
@@ -64,5 +66,5 @@
   luaopen_math(luaState);
   luaopen_debug(luaState);
-  
+
   this->loadFile(filename);
 
@@ -98,10 +100,10 @@
 bool Script::loadFile(const std::string& filename)
  {
-   std::string filedest(ResourceManager::getInstance()->getDataDir());
-   filedest += "scripts/" + filename;
-   
+   std::string filedest(Resources::ResourceManager::getInstance()->mainGlobalPath().name());
+   filedest += "/scripts/" + filename;
+
    this->addThisScript();
    this->registerStandartClasses();
-   
+
    if(currentFile.length() != 0)
    {
@@ -142,5 +144,5 @@
    //printf(("Script %s: I am about to add %s of class %s\n",this->getName(),objectName.c_str(),className.c_str());
 
-   BaseObject* scriptClass = ClassList::getObject(className, CL_SCRIPT_CLASS);
+   ScriptClass* scriptClass = ScriptClass::objectList().getObject(className);
   // printf(("The script class for %s is at %p \n",className.c_str(),scriptClass);
    WorldObject tmpObj;
@@ -150,12 +152,12 @@
      if( !classIsRegistered(className) )
      {
-     static_cast<ScriptClass*>(scriptClass)->registerClass(this);
-     }
-
-     BaseObject* object = ClassList::getObject(objectName, className);
+       scriptClass->registerClass(this);
+     }
+
+     BaseObject* object = ObjectListBase::getBaseObject(className, objectName);
     // printf(("%s is at %p \n",objectName.c_str(),object);
      if (object != NULL && !objectIsAdded(objectName))
      {
-        static_cast<ScriptClass*>(scriptClass)->insertObject(this, object, false);
+        scriptClass->insertObject(this, object, false);
         tmpObj.name = objectName;
         registeredObjects.push_back(tmpObj);
@@ -169,5 +171,5 @@
  bool Script::executeFile()
  {
-   PRINT(2)("WARNING: script.executeFile is not implemented yet\n");
+   PRINTF(2)("script.executeFile is not implemented yet\n");
    /*if(currentFile.length() != 0)
    {
@@ -214,5 +216,5 @@
     if(error != 0)
     {
-      printf("SCRIPT %s : ERROR: Failed to execute function %s: \n",currentFile.c_str(),currentFunction.c_str());
+      PRINTF(1)("Script '%s' : Failed to execute function '%s': \n",currentFile.c_str(),currentFunction.c_str());
      reportError(error);
      //clean up
@@ -229,5 +231,5 @@
    }
    else
-     printf("SCRIPT %s : ERROR: no function selected.\n",currentFile.c_str());
+     PRINTF(1)("SCRIPT '%s' : no function selected.\n",currentFile.c_str());
 
    return false;
@@ -295,5 +297,5 @@
        lua_remove(luaState,-1*returnCount);
        returnCount--;
-       
+
      }
    }
@@ -352,9 +354,10 @@
 void Script::addThisScript()
 {
-  BaseObject* scriptClass = ClassList::getObject("Script", CL_SCRIPT_CLASS);
-   if (scriptClass != NULL)
-   {
-     static_cast<ScriptClass*>(scriptClass)->registerClass(this);
-     static_cast<ScriptClass*>(scriptClass)->insertObject(this, this,"thisscript", false);
+  ScriptClass* scriptClass = ScriptClass::objectList().getObject("Script");
+
+  if (scriptClass != NULL)
+   {
+     scriptClass->registerClass(this);
+     scriptClass->insertObject(this, this,"thisscript", false);
    }
 }
@@ -375,5 +378,5 @@
  {
    bool success = false;
-   
+
    //this->registerClass(std::string("Vector"));
     this->registerClass("ScriptTrigger");
@@ -382,10 +385,11 @@
    return success;
  }
- 
- 
+
+
  void Script::registerClass( const std::string& className)
  {
-   BaseObject* scriptClass = ClassList::getObject(className, CL_SCRIPT_CLASS);
+   ScriptClass* scriptClass = ScriptClass::objectList().getObject(className);
    //printf(("The script class for %s is at %p \n",className.c_str(),scriptClass);
+
    WorldObject tmpObj;
    if (scriptClass != NULL)
@@ -400,5 +404,5 @@
      }
    }
- 
+
  }
 
Index: trunk/src/lib/script_engine/script.h
===================================================================
--- trunk/src/lib/script_engine/script.h	(revision 9682)
+++ trunk/src/lib/script_engine/script.h	(revision 9869)
@@ -22,4 +22,5 @@
 class Script : public BaseObject
 {
+  ObjectListDeclaration(Script);
   public:
     Script(const TiXmlElement* root = NULL);
@@ -33,5 +34,5 @@
     bool loadFile(const std::string& filename);
     void addObject( const std::string& className,const std::string& objectName);
-    void registerClass(const std::string& className);                           //!< Register a class but dont add any instances 
+    void registerClass(const std::string& className);                           //!< Register a class but dont add any instances
 
     /// QUERRYING
Index: trunk/src/lib/script_engine/script_class.cc
===================================================================
--- trunk/src/lib/script_engine/script_class.cc	(revision 9682)
+++ trunk/src/lib/script_engine/script_class.cc	(revision 9869)
@@ -19,13 +19,14 @@
 #include <cassert>
 
+ObjectListDefinition(ScriptClass);
 /**
  * @brief standard constructor
  * @todo this constructor is not jet implemented - do it
 */
-ScriptClass::ScriptClass(const std::string& name, ClassID classID, ScriptMethod* scriptMethods)
-    : BaseObject(name)
+ScriptClass::ScriptClass(const std::string& name, const ClassID& classID, ScriptMethod* scriptMethods)
+    : BaseObject(name), _classID(classID)
 {
   assert(scriptMethods != NULL);
-  this->setClassID(CL_SCRIPT_CLASS, "ScriptClass");
+  this->registerObject(this, ScriptClass::_objectList);
 
   this->_classID = classID;
Index: trunk/src/lib/script_engine/script_class.h
===================================================================
--- trunk/src/lib/script_engine/script_class.h	(revision 9682)
+++ trunk/src/lib/script_engine/script_class.h	(revision 9869)
@@ -18,26 +18,24 @@
  * this should be used at the beginning of all the Classes that should be loadable (in the cc-file)
  */
-#define CREATE_SCRIPTABLE_CLASS(CLASS_NAME, CLASS_ID, SCRIPT_METHODS) \
-    tScriptClass<CLASS_NAME> global_##CLASS_NAME##_ScriptableClass(#CLASS_NAME, CLASS_ID, (new ScriptMethod)->SCRIPT_METHODS)
+#define CREATE_SCRIPTABLE_CLASS(CLASS_NAME, SCRIPT_METHODS) \
+    tScriptClass<CLASS_NAME> global_##CLASS_NAME##_ScriptableClass(#CLASS_NAME, CLASS_NAME::staticClassID(), (new ScriptMethod)->SCRIPT_METHODS)
 
 
 //! A class for ...
-class ScriptClass : protected BaseObject
+class ScriptClass : public BaseObject
 {
+  ObjectListDeclaration(ScriptClass);
 
 public:
   virtual ~ScriptClass();
 
-  bool operator==(const std::string& name) { return (this->getName() == name); }
-  bool operator==(ClassID classID) { return (this->_classID == classID); }
-
   virtual void registerClass(Script* script) = 0;
   virtual int insertObject(Script* L, BaseObject* obj, bool gc=false) = 0;
-  virtual int insertObject(Script* L, BaseObject* obj, const std::string& name, bool gc=false) = 0; 
+  virtual int insertObject(Script* L, BaseObject* obj, const std::string& name, bool gc=false) = 0;
 
   const ScriptMethod* scriptMethods() const { return this->_scriptMethods; }
 
 protected:
-  ScriptClass(const std::string& name, ClassID classID, ScriptMethod* scriptMethods);
+  ScriptClass(const std::string& name, const ClassID& classID, ScriptMethod* scriptMethods);
 
 private:
Index: trunk/src/lib/script_engine/script_manager.cc
===================================================================
--- trunk/src/lib/script_engine/script_manager.cc	(revision 9682)
+++ trunk/src/lib/script_engine/script_manager.cc	(revision 9869)
@@ -24,11 +24,8 @@
 #include "lunar.h"
 
-#include "class_list.h"
-
 #include "script.h"
 #include "script_trigger.h"
 #include "luaincl.h"
-#include "loading/load_param.h"
-#include "parser/tinyxml/tinyxml.h"
+#include "loading/load_param_xml.h"
 
 
@@ -37,6 +34,4 @@
 {
   this->setName("ScriptManager");
-  this->scripts = NULL;
-  this->triggers = NULL;
 
   if (root != NULL)
@@ -62,6 +57,4 @@
 
   // fill the scripts and triggers (doing that on runtime is very slow!)
-  getTriggers();
-  getScripts();
 }
 
@@ -71,12 +64,10 @@
 {
   //Delete all scripts as they aren't deleted automatically
-  if(this->getScripts())
-    while(!scripts->empty())
-      delete scripts->front();
+  while(!Script::objectList().empty())
+    delete Script::objectList().front();
   //Delete all triggers
-  if(this->getTriggers())
-    while(!triggers->empty())
-      delete triggers->front();
-  
+  while(!ScriptTrigger::objectList().empty())
+    delete ScriptTrigger::objectList().front();
+
 }
 
@@ -105,28 +96,11 @@
 Script* ScriptManager::getScriptByFile(const std::string& file)
 {
-  if(getScripts())
-    for(std::list<BaseObject*>::const_iterator it = scripts->begin(); it != scripts->end(); it++ )
-    {
-      if( (dynamic_cast<Script*>(*it))->getFileName().compare(file) == 0)
-      {
-        return dynamic_cast<Script*>(*it);
-      }
-    }
+  for (ObjectList<Script>::const_iterator it = Script::objectList().begin();
+       it != Script::objectList().end();
+       ++it)
+    if( ((*it))->getFileName().compare(file) == 0)
+      return (*it);
 
   return NULL;
 
 }
-
-
-bool ScriptManager::getScripts()
-{
-  return (this->scripts != NULL || (this->scripts = ClassList::getList(CL_SCRIPT)) != NULL);
-}
-
-bool ScriptManager::getTriggers()
-{
-  return (this->triggers != NULL || (this->triggers = ClassList::getList(CL_SCRIPT_TRIGGER)) != NULL);
-}
-
-
-
Index: trunk/src/lib/script_engine/script_manager.h
===================================================================
--- trunk/src/lib/script_engine/script_manager.h	(revision 9682)
+++ trunk/src/lib/script_engine/script_manager.h	(revision 9869)
@@ -34,14 +34,5 @@
    void  createTriggers(const TiXmlElement* triggers);
 
-   bool getTriggers();
-   bool getScripts();
-
    static ScriptManager*             singletonRef;   //!< Reference to this class
-
-   const std::list<BaseObject*>*     triggers;       //!< A list of all the triggers in the world
-
-   const std::list<BaseObject*>*     scripts;        //!< A list of all the scripts in the world
-
-
 };
 #endif
Index: trunk/src/lib/script_engine/script_method.cc
===================================================================
--- trunk/src/lib/script_engine/script_method.cc	(revision 9682)
+++ trunk/src/lib/script_engine/script_method.cc	(revision 9869)
@@ -25,5 +25,5 @@
 { }
 
-ScriptMethod* ScriptMethod::addMethod(const std::string& methodName, const Executor& executor)
+ScriptMethod* ScriptMethod::addMethod(const std::string& methodName, const Executor<lua_State*>& executor)
 {
   this->methods.push_back(ScriptMethod::Method(methodName, executor));
@@ -32,5 +32,5 @@
 }
 
-ScriptMethod::Method::Method(const std::string& name, const Executor& executor)
+ScriptMethod::Method::Method(const std::string& name, const Executor<lua_State*>& executor)
 {
   this->name = name;
Index: trunk/src/lib/script_engine/script_method.h
===================================================================
--- trunk/src/lib/script_engine/script_method.h	(revision 9682)
+++ trunk/src/lib/script_engine/script_method.h	(revision 9869)
@@ -9,6 +9,6 @@
 #include <vector>
 
-#include "executor/executor_lua.h"
-
+#include "executor_lua_state.h"
+#include "executor/executor_member.h"
 
 class ScriptMethod
@@ -18,10 +18,10 @@
   ~ScriptMethod();
 
-  ScriptMethod* addMethod(const std::string& methodName, const Executor& executor);
+  ScriptMethod* addMethod(const std::string& methodName, const Executor<lua_State*>& executor);
 
   unsigned int size() const { return methods.size(); };
 
   const std::string& name(unsigned int methodNumber) const { return methods[methodNumber].name; };
-  const Executor* executor(unsigned int methodNumber) const { return methods[methodNumber].executor; };
+  const Executor<lua_State*>* executor(unsigned int methodNumber) const { return methods[methodNumber].executor; };
 
 
@@ -29,7 +29,7 @@
   struct Method
   {
-    Method(const std::string& name, const Executor& executor);
-    std::string    name;
-    Executor*      executor;
+    Method(const std::string& name, const Executor<lua_State*>& executor);
+    std::string             name;
+    Executor<lua_State*>*   executor;
   };
 
Index: trunk/src/lib/shell/Makefile.am
===================================================================
--- trunk/src/lib/shell/Makefile.am	(revision 9682)
+++ trunk/src/lib/shell/Makefile.am	(revision 9869)
@@ -6,5 +6,4 @@
 libORXshell_a_SOURCES = \
 		shell.cc \
-		shell_buffer.cc \
 		shell_input.cc \
 		shell_command.cc \
@@ -16,8 +15,7 @@
 noinst_HEADERS= \
 		shell.h \
-		shell_buffer.h \
 		shell_input.h \
+		shell_command_class.h \
 		shell_command.h \
-		shell_command_class.h \
 		shell_completion.h \
 		shell_completion_plugin.h
Index: trunk/src/lib/shell/shell.cc
===================================================================
--- trunk/src/lib/shell/shell.cc	(revision 9682)
+++ trunk/src/lib/shell/shell.cc	(revision 9869)
@@ -18,5 +18,5 @@
 #include "shell.h"
 #include "shell_command.h"
-#include "shell_buffer.h"
+#include "debug_buffer.h"
 #include "shell_input.h"
 
@@ -54,4 +54,5 @@
   ->completionPlugin(0, OrxShell::CompletorFileSystem(".ttf", "fonts/"));
 
+  ObjectListDefinition(Shell);
 
   /**
@@ -60,8 +61,9 @@
   Shell::Shell ()
   {
-    this->setClassID(CL_SHELL, "Shell");
+    this->registerObject(this, Shell::_objectList);
+
     this->setName("Shell");
 
-    this->shellBuffer = ShellBuffer::getInstance();
+    this->shellBuffer = DebugBuffer::getInstance();
 
     // EVENT-Handler subscription of '`' to all States.
@@ -246,7 +248,5 @@
     this->setSizeX2D(width);
     for (std::list<MultiLineText*>::iterator textIt = this->bufferText.begin(); textIt != this->bufferText.end(); ++textIt)
-    {
       (*textIt)->setLineWidth(width);
-    }
   }
 
@@ -444,5 +444,5 @@
   {
     this->flush();
-    ShellBuffer::addBufferLineStatic("orxonox - shell\n ==================== \n", NULL);
+    DebugBuffer::addBufferLineStatic("orxonox - shell\n ==================== \n", NULL);
   }
 
@@ -470,9 +470,9 @@
         this->moveDisplayBuffer(-this->bufferDisplaySize+1);
       }
-      else if (event.type == EV_VIDEO_RESIZE)
-      {
-        this->updateResolution(event.resize.w);
-        this->repositionText();
-      }
+    }
+    else if (event.type == EV_VIDEO_RESIZE)
+    {
+      this->updateResolution(event.resize.w);
+      this->repositionText();
     }
   }
Index: trunk/src/lib/shell/shell.h
===================================================================
--- trunk/src/lib/shell/shell.h	(revision 9682)
+++ trunk/src/lib/shell/shell.h	(revision 9869)
@@ -14,5 +14,5 @@
 
 #include "shell_input.h"
-#include "shell_buffer.h"
+#include "debug_buffer.h"
 #include "material.h"
 
@@ -48,5 +48,5 @@
   class Shell : public Element2D, public EventListener
   {
-
+    ObjectListDeclaration(Shell);
   public:
     Shell();
@@ -93,5 +93,5 @@
   private:
     // GENERAL
-    ShellBuffer*                shellBuffer;            //!< The local ShellBuffer.
+    DebugBuffer*                shellBuffer;            //!< The local ShellBuffer.
 
     bool                        bActive;                //!< If the shell is active.
Index: trunk/src/lib/shell/shell_command.cc
===================================================================
--- trunk/src/lib/shell/shell_command.cc	(revision 9682)
+++ trunk/src/lib/shell/shell_command.cc	(revision 9869)
@@ -20,6 +20,6 @@
 
 #include "compiler.h"
+#include "helper_functions.h"
 #include "debug.h"
-#include "class_list.h"
 
 #include "key_names.h"
@@ -27,4 +27,5 @@
 namespace OrxShell
 {
+  ObjectListDefinition(ShellCommand);
   SHELL_COMMAND(debug, ShellCommandClass, help);
 
@@ -36,7 +37,7 @@
    * @param paramCount the count of parameters this command takes
    */
-  ShellCommand::ShellCommand(const std::string& commandName, const std::string& className, Executor* executor)
-  {
-    this->setClassID(CL_SHELL_COMMAND, "ShellCommand");
+  ShellCommand::ShellCommand(const std::string& commandName, const std::string& className, Executor<const SubString>* executor)
+  {
+    this->registerObject(this, ShellCommand::_objectList);
     PRINTF(4)("create shellcommand '%s' for class '%s'\n", commandName.c_str(), className.c_str());
     this->setName(commandName);
@@ -44,5 +45,4 @@
     // copy the executor:
     this->executor = executor;
-    this->executor->setName(commandName);
 
     for (unsigned int i = 0; i < this->executor->getParamCount(); i++)
@@ -75,5 +75,5 @@
    * @brief registers a new ShellCommand
    */
-  ShellCommand* ShellCommand::registerCommand(const std::string& commandName, const std::string& className, Executor* executor)
+  ShellCommand* ShellCommand::registerCommand(const std::string& commandName, const std::string& className, Executor<const SubString>* executor)
   {
     if (ShellCommand::exists(commandName, className))
@@ -94,10 +94,9 @@
   void ShellCommand::unregisterCommand(const std::string& commandName, const std::string& className)
   {
-
     ShellCommandClass* cmdClass = ShellCommandClass::acquireCommandClass(className);
     if (cmdClass != NULL)
     {
       CmdList::iterator cmd;
-      for (cmd = cmdClass->commandList.begin(); cmd != cmdClass->commandList.end(); cmd++)
+      for (cmd = cmdClass->_commandList.begin(); cmd != cmdClass->_commandList.end(); cmd++)
         if (commandName == (*cmd)->getName())
         {
@@ -119,8 +118,8 @@
 
     CmdList::const_iterator elem;
-    for (unsigned int i = 0; i < cmdClass->commandList.size(); i++)
-    {
-      if (commandName == cmdClass->commandList[i]->getName())
-        return (cmdClass->commandList[i]);
+    for (unsigned int i = 0; i < cmdClass->_commandList.size(); i++)
+    {
+      if (commandName == cmdClass->_commandList[i]->getName())
+        return (cmdClass->_commandList[i]);
     }
     return NULL;
@@ -242,21 +241,23 @@
       return false;
 
-    const std::list<BaseObject*>* objectList = ClassList::getList(cmd->shellClass->getName());
+    const ObjectListBase* const objectList = ObjectListBase::getObjectList(cmd->shellClass->getName());
     if (objectList != NULL)
     {
-      std::list<BaseObject*>::const_iterator bo;
+      ObjectListBase::base_list list;
+      objectList->getBaseObjectList(&list);
+      ObjectListBase::base_iterator it;
 
       // No Description given (only for speedup)
       if (objectDescriptor.empty())
       {
-        for (bo = objectList->begin(); bo != objectList->end(); bo++)
-          boList->push_back(*bo);
+        for (it = list.begin(); it != list.end(); it++)
+          boList->push_back(*it);
       }
       // some description
       else
       {
-        for (bo = objectList->begin(); bo != objectList->end(); bo++)
-          if (!nocaseCmp(objectDescriptor, (*bo)->getName(), objectDescriptor.size()))
-            boList->push_back(*bo);
+        for (it = list.begin(); it != list.end(); it++)
+          if (!nocaseCmp(objectDescriptor, (*it)->getName(), objectDescriptor.size()))
+            boList->push_back(*it);
       }
     }
@@ -299,9 +300,16 @@
     if (sc != NULL)
     {
-      for(std::vector<BaseObject*>::const_iterator bo = boList.begin(); bo != boList.end(); ++bo)
-      {
-        PRINT(0)("Command '%s' on '%s::%s'\n", sc->getCName(), (*bo)->getClassCName(), (*bo)->getCName());
-        (*sc->executor)((*bo), inputSplits.subSet(paramBegin));
-      }
+
+      if(sc->executor->getType() == Executor<const SubString>::FunctionStatic )
+      {
+	PRINT(0)("Static Command '%s' of Class '%s' with parameters\n", sc->getCName(), sc->shellClass->getCName());
+	(*sc->executor)(NULL, inputSplits.subSet(paramBegin));
+      }
+      else
+        for(std::vector<BaseObject*>::const_iterator bo = boList.begin(); bo != boList.end(); ++bo)
+        {
+          PRINT(0)("Command '%s' on '%s::%s'\n", sc->getCName(), (*bo)->getClassCName(), (*bo)->getCName());
+          (*sc->executor)((*bo), inputSplits.subSet(paramBegin));
+        }
       return true;
     }
@@ -376,7 +384,7 @@
     else
     {
-//       if(this->completors[parameter] == NULL)
-//       delete this->completors[parameter];
-//       this->completors[parameter] = completorPlugin.clone();
+      //       if(this->completors[parameter] == NULL)
+      //       delete this->completors[parameter];
+      //       this->completors[parameter] = completorPlugin.clone();
     }
     return this;
Index: trunk/src/lib/shell/shell_command.h
===================================================================
--- trunk/src/lib/shell/shell_command.h	(revision 9682)
+++ trunk/src/lib/shell/shell_command.h	(revision 9869)
@@ -9,5 +9,10 @@
 #include "base_object.h"
 
-#include "executor/executor.h"
+/// THIS IS USED TO LOAD CONSTANT AND STATIC FUNCTIONS EASILY.
+#include "executor/executor_substring.h"
+#include "executor/functor_member.h"
+#include "executor/functor_const_member.h"
+#include "executor/functor_static.h"
+
 #include "shell_completion_plugin.h"
 
@@ -35,5 +40,5 @@
    */
 #define SHELL_COMMAND(command, class, function) \
-           OrxShell::ShellCommand* shell_command_##class##_##command = OrxShell::ShellCommand::registerCommand(#command, #class, createExecutor<class>(&class::function))
+           OrxShell::ShellCommand* shell_command_##class##_##command = OrxShell::ShellCommand::registerCommand(#command, #class, createExecutor<class, BaseObject>(&class::function))
 
   /**
@@ -51,5 +56,5 @@
    */
 #define SHELL_COMMAND_STATIC(command, class, function) \
-           OrxShell::ShellCommand* shell_command_##class##_##command = OrxShell::ShellCommand::registerCommand(#command, #class, createExecutor<class>(function))
+           OrxShell::ShellCommand* shell_command_##class##_##command = OrxShell::ShellCommand::registerCommand(#command, #class, createExecutor<class, BaseObject>(function))
 
 
@@ -58,4 +63,6 @@
   class ShellCommand : public BaseObject
   {
+    ObjectListDeclaration(ShellCommand);
+
     friend class ShellCommandClass;
   public:
@@ -69,5 +76,5 @@
     ShellCommand* completionPlugin(unsigned int parameter, const CompletorPlugin& completorPlugin);
 
-    static ShellCommand* registerCommand(const std::string& commandName, const std::string& className, Executor* executor);
+    static ShellCommand* registerCommand(const std::string& commandName, const std::string& className, Executor<const SubString>* executor);
     static void unregisterCommand(const std::string& commandName, const std::string& className);
     static const ShellCommand* const getCommand(const std::string& commandName, const std::string& className);
@@ -85,5 +92,5 @@
 
   protected:
-    ShellCommand(const std::string& commandName, const std::string& className, Executor* executor);
+    ShellCommand(const std::string& commandName, const std::string& className, Executor<const SubString>* executor);
     virtual ~ShellCommand();
 
@@ -97,5 +104,5 @@
     std::string                      description;           //!< A description for this commnand. (initially ""). Assigned with (create)->describe("blablabla");
     std::vector<CompletorPlugin*>    completors;            //!< Completors for the Parameters
-    Executor*                        executor;              //!< The Executor, that really executes the Function.
+    Executor<const SubString>*       executor;              //!< The Executor, that really executes the Function.
   };
 
